import 'package:angular_forms/angular_forms.dart';
import 'package:fo_components/fo_components.dart';
import '../services/firestore/firestore_service_base.dart';

class BoValidators {
  static ValidatorFn unique(String property, String error_phrase,
          FirestoreService service, FoModel model) =>
      (control) {
        if ((FoValidators.required())(control) != null || service == null)
          return null;

        final models = service.cachedModels.values
            .where((model) => model.toJson()[property] == control.value)
            .toList();
        if (model.id != null) models.removeWhere((m) => m.id == model.id);
        if (models.isEmpty)
          return null;
        else {
          return {'error': new PhraseService().get(error_phrase)};
        }
      };

  static Map<String, String> cancelBookingCode(AbstractControl control) {
    if ((FoValidators.required()(control)) != null) return null;

    final r = new RegExp('[A-Z]{3}[0-9]{3}');
    if (r.allMatches(control.value).length != control.value.length) {
      final ps = new PhraseService();
      return {'error': ps.get('enter_valid_cancel_booking_code')};
    } else
      return null;
  }
}
